﻿Imports System.IO

Public Class Form1
    Private m_FileName As String = ""

    ' Load a file and set the form's MdiParent.
    Public Sub LoadFile(ByVal file_name As String, ByVal mdi_parent As MDIParent1)
        ' Save the file name and MdiParent.
        m_FileName = file_name
        Me.MdiParent = mdi_parent

        ' Load the file.
        txtContents.Text = File.ReadAllText(m_FileName)
        txtContents.Select(0, 0)

        ' Display the file name.
        Me.Text = New FileInfo(m_FileName).Name

        ' The data has not been modified since it was loaded.
        txtContents.Modified = False
    End Sub

    ' Close the form.
    Private Sub mnuFileClose_Click() Handles mnuFileClose.Click
        Me.Close()
    End Sub

    ' See if it's safe to close the form.
    Private Sub mdiChild_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        If txtContents.Modified Then
            ' There are unsaved changes.
            ' Ask the user if we should save them.
            Select Case MessageBox.Show( _
                    "The data has changed. Save the changes?", _
                    "Save Changes?", _
                    MessageBoxButtons.YesNoCancel, _
                    MessageBoxIcon.Question)
                Case Windows.Forms.DialogResult.Yes
                    ' Save the changes.
                    SaveFile()

                    ' See if we succeeded.
                    e.Cancel = txtContents.Modified
                Case Windows.Forms.DialogResult.No
                    ' Discard the changes.
                    ' Leave e.Cancel = False.
                Case Windows.Forms.DialogResult.Cancel
                    ' Cancel the close.
                    e.Cancel = True
            End Select
        End If
    End Sub

    ' Save the file.
    Private Sub SaveFile()
        File.WriteAllText(m_FileName, txtContents.Text)
        txtContents.Modified = False
        Me.Text = New FileInfo(m_FileName).Name
    End Sub

    ' Mark the data as modified.
    Private Sub txtContents_TextChanged() Handles txtContents.TextChanged
        txtContents.Modified = True
        If Not Me.Text.EndsWith("*") Then
            If m_FileName.Length > 0 Then
                Me.Text = New FileInfo(m_FileName).Name & "*"
            Else
                Me.Text = "*"
            End If
        End If
    End Sub

    ' Save the changes.
    Private Sub mnuFileSave_Click() Handles mnuFileSave.Click
        SaveFile()
    End Sub
End Class
