﻿Public Class Form1
    Private Sub mnuFileOpen_Click() Handles mnuFileOpen.Click
        If dlgOpenImage.ShowDialog() = Windows.Forms.DialogResult.OK Then
            ' Load and display the image.
            Dim bm As New Bitmap(dlgOpenImage.FileName)
            Dim source_bm As New Bitmap(bm)
            bm.Dispose()
            picSource.Image = source_bm

            ' Arrange the controls.
            picDest.Size = picSource.Size

            ' Make the result Bitmap.
            Dim dest_bm As New Bitmap(source_bm)

            ' Invert the image's pixels.
            Dim start_time As DateTime
            Dim stop_time As DateTime
            Dim elapsed_time As TimeSpan
            start_time = Now
            InvertImage(dest_bm)
            stop_time = Now

            ' Display the results.
            picDest.Image = dest_bm

            elapsed_time = stop_time.Subtract(start_time)
            MessageBox.Show(elapsed_time.TotalSeconds.ToString("0.0000") & " seconds")
        End If
    End Sub

    ' Invert the pixel values in this Bitmap. 
    Private Sub InvertImage(ByVal bm As Bitmap)
        ' Make a BitmapBytesRGB24 object.
        Dim bm_bytes As New BitmapBytesRGB24(bm)

        ' Lock the bitmap.
        bm_bytes.LockBitmap()

        Dim pix As Integer
        For y As Integer = 0 To bm.Height - 1
            pix = y * bm_bytes.RowSizeBytes
            For x As Integer = 0 To bm.Width - 1
                ' Blue component.
                bm_bytes.ImageBytes(pix) = CByte(255) - bm_bytes.ImageBytes(pix)
                pix += 1
                ' Green component.
                bm_bytes.ImageBytes(pix) = CByte(255) - bm_bytes.ImageBytes(pix)
                pix += 1
                ' Red component.
                bm_bytes.ImageBytes(pix) = CByte(255) - bm_bytes.ImageBytes(pix)
                pix += 1
            Next x
        Next y

        ' Unlock the bitmap.
        bm_bytes.UnlockBitmap()
    End Sub
End Class
